package com.fp.persistence.pgeneral.report;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEREPORTDETAIL*/
@Embeddable
public class TgeneReportDetailKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="REPORTCODE", nullable=false,updatable=false)

/**
* Nombre del Reporte
*/
private String reportcode;

@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="REPORTPARAMETER", nullable=false,updatable=false)

/**
* Nombre de parametro con el cual se invoca al reporte.
*/
private String reportparameter;

/**Contructor por defecto*/
public TgeneReportDetailKey(){}
/**Contructor de TgeneReportDetailKey
@param pReportcode Nombre del Reporte
@param pModulecode Codigo de modulo
@param pReportparameter Nombre de parametro con el cual se invoca al reporte.
*/
public TgeneReportDetailKey(String pReportcode,String pModulecode,String pReportparameter){
 reportcode=pReportcode;
 modulecode=pModulecode;
 reportparameter=pReportparameter;
}
/**Obtiene el valor de reportcode
@return valor de reportcode*/
public String getReportcode(){
  return reportcode;
}
/**Fija el valor de reportcode
@param pReportcode nuevo Valor de reportcode*/
public void setReportcode(String pReportcode){
  reportcode=pReportcode;
}

/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de reportparameter
@return valor de reportparameter*/
public String getReportparameter(){
  return reportparameter;
}
/**Fija el valor de reportparameter
@param pReportparameter nuevo Valor de reportparameter*/
public void setReportparameter(String pReportparameter){
  reportparameter=pReportparameter;
}

/**Implementación de la comparación de TgeneReportDetailKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneReportDetailKey))return false;
  TgeneReportDetailKey that = (TgeneReportDetailKey) o;
  if (this.getReportcode() == null || that.getReportcode() == null){
      return false;
  }
  if (! this.getReportcode().equals(that.getReportcode())){
    return false;
  }
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getReportparameter() == null || that.getReportparameter() == null){
      return false;
  }
  if (! this.getReportparameter().equals(that.getReportparameter())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneReportDetailKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getReportcode() == null ? 0 : this.getReportcode().hashCode());
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getReportparameter() == null ? 0 : this.getReportparameter().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
